import ApiError from "@shared/erros/apiError";
import { inject, injectable } from "tsyringe";
import {
  MoviesDiffInterval,
  ProducerIntervalDto,
  ProducerMinMaxIntervalDto,
  ProducersMinMaxIntervalResponseDto,
} from "../dto/producersMinMaxInterval.dto";
import Movie from "../models/movie.model";
import ProducerRepository from "../repositories/producer.repository";

@injectable()
class GetProducersMinMaxIntervalService {
  constructor(
    @inject("ProducerRepository")
    private producerRepository: ProducerRepository
  ) {}

  async execute(): Promise<ProducersMinMaxIntervalResponseDto | null> {
    try {
      const producers = await this.producerRepository.findWinnersMoreThanOnce();

      const producersInterval = producers.map((p) => {
        const diffMovies = this.findDiffMovies(p.movies);
        return {
          producer: p.name,
          interval: diffMovies,
        } as ProducerIntervalDto;
      });

      let producersMinInterval = this.reduceProducers(producersInterval, true);
      let producersMaxInterval = this.reduceProducers(producersInterval, false);

      const min = producersMinInterval.map((p) =>
        this.createProducerFromInterval({
          producerName: p.producer,
          interval: p.interval.min,
          years: p.interval.minPair,
        })
      );
      const max = producersMaxInterval.map((p) =>
        this.createProducerFromInterval({
          producerName: p.producer,
          interval: p.interval.max,
          years: p.interval.maxPair,
        })
      );

      return {
        min,
        max,
      } as ProducersMinMaxIntervalResponseDto;
    } catch (error: any) {
      console.log(error);
      throw new ApiError({
        message: `Failuere when get producers: ${error.message}`,
      });
    }
  }

  private reduceProducers(
    producers: ProducerIntervalDto[],
    checkMin: boolean
  ): ProducerIntervalDto[] {
    return producers.reduce(
      (acc: ProducerIntervalDto[], curr: ProducerIntervalDto) => {
        if (checkMin) {
          if (acc[0] == undefined || curr.interval.min < acc[0].interval.min) {
            acc = [curr];
          } else if (curr.interval.min == acc[0].interval.min) {
            acc.push(curr);
          }
        } else {
          if (acc[0] == undefined || curr.interval.max > acc[0].interval.max) {
            acc = [curr];
          } else if (curr.interval.max == acc[0].interval.max) {
            acc.push(curr);
          }
        }

        return acc;
      },
      []
    );
  }

  private findDiffMovies(movies: Movie[]): MoviesDiffInterval {
    //generated by gpt
    let min = Infinity;
    let max = -Infinity;
    let minPair: number[] = [];
    let maxPair: number[] = [];
    let diff = 0;

    movies.sort((a, b) => a.year - b.year);

    for (let i = 0; i < movies.length - 1; i++) {
      diff = Math.abs(movies[i + 1].year - movies[i].year);

      if (diff < min) {
        min = diff;
        minPair = [movies[i].year, movies[i + 1].year];
      }

      if (diff > max) {
        max = diff;
        maxPair = [movies[i].year, movies[i + 1].year];
      }
    }

    return {
      min,
      max,
      minPair,
      maxPair,
    };
  }

  private createProducerFromInterval(value: {
    producerName: string;
    interval: number;
    years: number[];
  }): ProducerMinMaxIntervalDto {
    return {
      producer: value.producerName,
      interval: value.interval,
      previousWin: Math.min(...value.years),
      followingWin: Math.max(...value.years),
    } as ProducerMinMaxIntervalDto;
  }
}

export default GetProducersMinMaxIntervalService;
